ReferenceStorage(T) - Crystal 1.21.0

# struct ReferenceStorage(T)

- ReferenceStorage(T)
- Value
- Object

##
Overview

`ReferenceStorage(T)` provides the minimum storage for the instance data of an object of type `T`. The compiler guarantees that `sizeof(ReferenceStorage(T)) == instance_sizeof(T)` and `alignof(ReferenceStorage(T)) == instance_alignof(T)` always hold, which means `Pointer(ReferenceStorage(T))` and `T` are binary-compatible.

`T` must be a non-union reference type.

WARNING `ReferenceStorage` is only necessary for manual memory management, such as creating instances of `T` with a non-default allocator. Therefore, this type is unsafe and no public constructors are defined.

WARNING `ReferenceStorage` is unsuitable when instances of `T` require more than `instance_sizeof(T)` bytes, such as `String` and `Log::Metadata`.

EXPERIMENTAL This type's API is still under development. Join the discussion about custom reference allocation at #13481.

##
Defined in:

reference_storage.cr

##
Instance Method Summary

- #==(other : ReferenceStorage(T)) : Bool

  Returns whether `self` and other are bytewise equal.

- #==(other) : Bool

  Returns `false`.

- #hash(hasher)

  Appends this object's value to hasher, and returns the modified hasher.

- #to_reference : T

  Returns a `T` whose instance data refers to `self`.

- #to_s(io : IO) : Nil

  Prints a nicely readable and concise string representation of this object, typically intended for users, to io.

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Instance Method Detail

def ==(other : ReferenceStorage(T)) : Bool #

Returns whether `self` and other are bytewise equal.

NOTE This does not call `T#==`, so it works even if `self` or other does not represent a valid instance of `T`. If validity is guaranteed, call `to_reference == other.to_reference` instead to use `T#==`.

def ==(other) : Bool #
Description copied from struct Value

Returns `false`.

def hash(hasher) #
Description copied from class Object

Appends this object's value to hasher, and returns the modified hasher.

Usually the macro `def_hash` can be used to generate this method. Otherwise, invoke `#hash(hasher)` on each object's instance variables to accumulate the result:

    def hash(hasher)
      hasher = @some_ivar.hash(hasher)
      hasher = @some_other_ivar.hash(hasher)
      hasher
    end

def to_reference : T #

Returns a `T` whose instance data refers to `self`.

WARNING The caller is responsible for ensuring that the instance data is correctly initialized and outlives the returned `T`.

def to_s(io : IO) : Nil #
Description copied from class Object

Prints a nicely readable and concise string representation of this object, typically intended for users, to io.

This method is called when an object is interpolated in a string literal:

    "foo #{bar} baz" # calls bar.to_io with the builder for this string

`IO#<<` calls this method to append an object to itself:

    io << bar # calls bar.to_s(io)

Thus implementations must not interpolate `self` in a string literal or call `io << self` which both would lead to an endless loop.

Also see `#inspect(IO)`.